#ifndef LIST_
#define LIST_

#include <stdlib.h>
#include <string.h>
#include <iostream.h>

template<class T> class List {
    unsigned long n;
    unsigned long nmax;
    unsigned long ninc;
    T** data;
  public:
    List(unsigned long ni=10) {
      ninc=ni;
      nmax=ni;
      n=0;
      data=new T* [nmax];
    }
    
    unsigned long Size() { return n; }
    
    void Clear(int del=0) { 
      if (del) {
	unsigned int i;

	for (i=0;i<n;i++)
	  if (data[i]!=NULL) 
	    delete data[i];
      }
      delete data;
      nmax=ninc;
      data=new T* [nmax];
      n=0;
    }
    
    void Add(T* t) {
      if (n==nmax) {
	T** odata=data;
	nmax+=ninc;
	data=new T* [nmax];
	memcpy(data,odata,sizeof(T*)*n);
	delete odata;
      }
      data[n]=t;
      n++;
    }
    
    void Ins(T* t,unsigned long i) {
      unsigned long j;
      
      if ((0<=i) && (i<=n)) {
	if (n==nmax) {
	  T** odata=data;
	  nmax+=ninc;
	  data=new T* [nmax];
	  memcpy(data,odata,sizeof(T*)*n);
	  delete odata;
	}
	for (j=n;j>i;j--)
	  data[j]=data[j-1];
	data[i]=t;
	n++;
      }
    }
    
    void Del(unsigned long i) {
      unsigned long j;
      
      if ((0<=i) && (i<n)) {
	for (j=i;j<n-1;j++)
	  data[j]=data[j+1];
	n--;
      }
    }
    
    void Del(T* t) {
      unsigned long i;
      i=Find(t);
      Del(i);
    }
    
    unsigned long Find(T* t) {
      unsigned long i;
      
      for (i=0;i<n;i++)
	if (data[i]==t)
	  return i;
      return n+1;         /* n+1 if t not in list */
    }
    
    T* Get(unsigned long i) {
      if ((0<=i) &&  (i<n))
	return data[i];
      return (T*)NULL;
    }
    
    ~List() {
      delete data;
    }
};

#endif
